${
$include <stdio.h>
$include <stdlib.h>
$include <time.h>
$include <sys/times.h>
$include <limits.h>
$include <time.h>
typedef unsigned long long int ullong;
$}

#include "common.h"

#if BPF == 64
	#define FRAGTYPE p64_t
	#define FRAGCTYPE ullong
	#define FRAGEXT uq
#else
	#define FRAGTYPE p32_t
	#define FRAGCTYPE unsigned
	#define FRAGEXT ud
#endif

${
struct tms junk;
clock_t start, end, comptime;
$}

void f(unsigned int:2[LENGTH] DNA, unsigned int total)
{
	unsigned int:2[3] substring;
	unsigned int:2[LENGTH] count;
	unsigned int i;

	substring[0]=A; substring[1]=G; substring[2]=T;

/*
	${ start = times(&junk); $}
*/

	count = 0;
	for (i=0; i<3; ++i) {
		count = count[<< 1];
		count += (DNA == substring[i])? 1:0;
	}

	count = (count == 3)? 1:0;
	total += count;

/*
	${
		end = times(&junk);
		printf("Time elapsed for %d element check: %ld (%ld, %ld)\n",
			LENGTH, end-start, end, start);
	$}
*/
}

${
int main(void)
{
	int iters, i, j;
	unsigned int total = 0;
	FRAGTYPE DNA[((2*LENGTH-1)/BPF)+1];

	#ifdef TIME_OVERALL
		start = times(&junk);
	#endif

	#ifdef TIME_COMPUTE
		comptime = 0ULL;
	#endif

	srand(SEED);
	for (iters=0; iters<ITERS; ++iters) {
		/* Full fragments - 32,31,...,0 */
		for (i=0; i<LENGTH/(BPF/2); ++i) {
			for (j=0; j<(BPF/2); ++j) {
			    DNA[i].FRAGEXT = (DNA[i].FRAGEXT>>2) |
				( ((FRAGCTYPE)(4.0*rand()/(RAND_MAX+1.0))&0x3)
				  << BPF-2 );
			}
		}

		/* Final, possibly partially-filled, fragment */
		if (i == (2*LENGTH-1)/BPF)
			DNA[i].FRAGEXT = 0ULL;
		for (j=0; j<LENGTH%(BPF/2); ++j) {
			DNA[i].FRAGEXT = (DNA[i].FRAGEXT>>2) |
				( ((FRAGCTYPE)(4.0*rand()/(RAND_MAX+1.0))&0x3)
				  << ((LENGTH%(BPF/2))*2)-2);
		}

		#ifdef DEBUG
			printf("DNA[i]=");
			for (i=0; i<LENGTH; ++i) {
			    j = (LENGTH-1-i)/(BPF/2);
			    printf("%d ",
				   (DNA[j].FRAGEXT >> 2*((LENGTH-1-i)%(BPF/2)))
				   & 0x3);
			}
			printf("\n");
		#endif

		#ifdef TIME_COMPUTE
			start = times(&junk);
		#endif
		f(DNA, &total);
		#ifdef TIME_COMPUTE
			end = times(&junk);
			comptime += (end-start);
		#endif
	}
	printf ("Total was %u.\n", total);

	#ifdef TIME_OVERALL
		end = times(&junk);
		printf("Time elapsed for %d element check: %ld (%ld, %ld)\n",
			LENGTH, end-start, end, start);
	#endif
	#ifdef TIME_COMPUTE
		printf("Time elapsed for %d element check: %ld\n",
			LENGTH, comptime);
	#endif

	return 0;
}
$}

